<html>
<head>
<title>GIC - <?php echo $type; ?></title>
</head>
<body bgcolor=#ffffff>

<!-- $Id: transaction.inc,v 1.5 2001/01/08 23:38:24 root Exp $ -->
<?php
#
#   transaction.inc, prepaid accounting, capture transactions
#   Copyright (C) 2000  James Cameron (quozl@us.netrek.org)
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

include('database.inc');

head('gic-'.strtolower($type).'.jpg');

function issue($name, $date, $comment, $amount, $colour_heading, $colour_detail) {

    echo '
<form method=get>
<table>

<tr>
<th align=right bgcolor='.$colour_heading.'>Login:</th>
<td bgcolor='.$colour_detail.'>'.$name.'<input type=hidden name=name value="'.$name.'"></td>
</tr>

<tr>
<th align=right bgcolor='.$colour_heading.'>Date:</th>
<td bgcolor='.$colour_detail.'><input type=text name=date size=16 value="'.$date.'"></td>
</tr>

<tr>
<th align=right bgcolor='.$colour_heading.'>Comment:</th>
<td bgcolor='.$colour_detail.'><input type=text name=comment size=64 value="'.$comment.'"</td>
</tr>

<tr>
<th align=right bgcolor='.$colour_heading.'>Amount:</th>
<td bgcolor='.$colour_detail.'><input type=text name=amount size=8 value="'.$amount.'"></td>
</tr>

<tr>
<td bgcolor='.$colour_heading.'>&nbsp;</td>
<td bgcolor='.$colour_detail.'><input type=submit value="Store"></td>
</tr>

</tr>
</table>
</form>
';
}

# emit hostname and date
echo '<div align=right><i><small>'.`date`.'</small></i></div>';

# if account name not given, prompt
if ($name == "") {
    echo "<form method=get>Login: <input type=text name=name size=16></form>";
    exit;
}

# force to lowercase
$name = strtolower($name);

# check account name valid
if (!account_exists($name)) {

    # isn't valid, see if we have an implied account
    $account = account_default($name);

    # still allow transactions for a user in /etc/passwd
    system('grep --silent '.escapeshellcmd($name).' /etc/passwd', $retval);
    if ($retval != 0) {
	echo 'No account named <i>'.$name.'</i><p>';
	echo "<form method=get>Login: <input type=text name=name size=16></form>";
	exit;
    }
} else {
    $account = account_read($name);
}

# if the form has not yet been submitted, issue it
if (!isset($date) | !isset($comment) | !isset($amount)) {

    # set defaults for empty form
    $date = date_to_string(date_default());
    $comment = $type;
    $amount = "";
    issue($name, $date, $comment, $amount, $colour_heading_one, ($sign
	  == 'Credit') ? $colour_detail_credit_one :
	  $colour_detail_debit_one);
    menu($name);
    exit;
}

echo "<p>";
$invalid = 0;

# validate input values
if (!date_from_string($date)) {
    echo "Error: Date not valid.<p>";
    $invalid++;
}

if ($comment == "") {
    echo "Error: Comment not entered.<p>";
    $invalid++;
}

if ($amount == "") {
    echo "Error: Amount not entered.<p>";
    $invalid++;
} else {
    $test = amount_to_string(amount_from_string($amount));
    if ($test != $amount) {
	echo "Error: 
Amount not in expected format.
You entered '$amount', which was converted to '$test'.
<p>
";
	$invalid++;
    }
}

if (amount_from_string($amount) < 0) {
    echo "Error: Amount is not positive.<p>";
    $invalid++;
}

if (amount_from_string($amount) == 0) {
    echo "Error: Amount is zero.<p>";
    $invalid++;
}

if ($invalid != 0) {
    issue($name, $date, $comment, $amount, $colour_heading_one, ($sign
	  == 'Credit') ? $colour_detail_credit_one :
	  $colour_detail_debit_one);
    exit;
}

# data has been validated

# create transaction 
$transaction['when'] = date_from_string($date);
$transaction['comment'] = $comment;
if ($sign == 'Credit') {
    $transaction['amount'] = amount_from_string($amount);
} else {
    $transaction['amount'] = - amount_from_string($amount);
}

# check to see if it already exists in the account
# (mainly to avoid browser "back" side effects)
if (account_find_transaction($account, $transaction) != -1) {
    echo "Error: an identical transaction already exists on file<p>";
    exit;
}

# append transaction to account
$account['transactions'][] = $transaction;

if (!account_write ($account)) {
    echo '<p>'.$type.' not stored.<p>';
    exit;
}

echo $type.' stored.';

menu($name);

# ??? generate tax invoice receipt here for payment

?>
<hr noshade><div align=right><small><i>
$Revision: 1.5 $ $Date: 2001/01/08 23:38:24 $
</i></small></div>
</body>
</html>
